//File:         CableProperty.java
//Project:      ProbeSim
//Version:      0.2
//Designer:     C. Edward Chow
//Revision:
//              1/14/2000  C. Edward Chow
//Bug Report:   send to chow@cs.uccs.edu
//Description:  Simulator for Internet Network Probing Research
//              Dialog Window class for enter property of Cable class.
//

package NetLayout;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class CableProperty extends Dialog implements ActionListener {
  final static int size = 30;
  Node n;
  NetLayoutFrame f;
  Cable cl;
  JPanel panel1 = new JPanel();
  JPanel panel3 = new JPanel();
  JPanel insetsPanel1 = new JPanel();
  JPanel insetsPanel3 = new JPanel();
  JSeparator sep1 = new JSeparator();
  JSeparator sep2 = new JSeparator();
  JSeparator sep3 = new JSeparator();
  Label statusBar = new Label();

  JButton button1 = new JButton();
  JButton button2 = new JButton();
  JLabel label1 = new JLabel();
  JLabel label2 = new JLabel();
  Label nameLabel = new Label("Name:", Label.RIGHT);
  TextField nameField;
  Label idLabel = new Label("ID:", Label.RIGHT);
  Label idField; // change not allowed
  Label xLabel = new Label("X:", Label.RIGHT);
  TextField xField;
  Label yLabel = new Label("Y:", Label.RIGHT);
  TextField yField;

  Label distanceLabel = new Label("Distance:", Label.RIGHT);
  TextField distanceField;
  Label bandwidthLabel = new Label("Bandwidth:", Label.RIGHT);
  TextField bandwidthField;
  Label n1Label = new Label("End Node 1:", Label.RIGHT);
  Label n1Field;
  Label n2Label = new Label("End Node 2:", Label.RIGHT);
  Label n2Field;

  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  String product = "Network Layout Tool Copyright (c) 1998";
  String dialogName = "Cable Property";

  public CableProperty(Frame parent, Cable c) {
    super(parent);
    f = (NetLayoutFrame) parent;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit(c);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    pack();
  }

  private void jbInit(Cable c) throws Exception  {
    this.setTitle("Cable Property");
    cl = c;
    setResizable(false);
    panel1.setLayout(borderLayout1);
    panel3.setLayout(borderLayout3);
    insetsPanel1.setLayout(flowLayout1);
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();
    insetsPanel3.setLayout(gbl);

    label1.setText(product);
    label2.setText(dialogName);

    button1.setText("UPDATE");
    button1.addActionListener(this);
    button2.setText("CANCEL");
    button2.addActionListener(this);
    insetsPanel1.add(button1, null);
    insetsPanel1.add(button2, null);
    panel1.add(insetsPanel1, BorderLayout.SOUTH);

    gbc.anchor = GridBagConstraints.CENTER;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(label1, gbc);
    insetsPanel3.add(label1);
    
    gbc.anchor = GridBagConstraints.CENTER;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(label2, gbc);
    insetsPanel3.add(label2);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep1, gbc);
    insetsPanel3.add(sep1);
    gbc.fill = 0;


    // add code to create name value pair for each property item

    nameField = new TextField(c.name, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(nameLabel, gbc);
    insetsPanel3.add(nameLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(nameField, gbc);
    insetsPanel3.add(nameField);
    
    idField = new Label(Integer.toString(c.ID),Label.LEFT);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(idLabel, gbc);
    insetsPanel3.add(idLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(idField, gbc);
    insetsPanel3.add(idField);

    xField = new TextField(Integer.toString(c.x), size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(xLabel, gbc);
    insetsPanel3.add(xLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(xField, gbc);
    insetsPanel3.add(xField);

    yField = new TextField(Integer.toString(c.y), size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(yLabel, gbc);
    insetsPanel3.add(yLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(yField, gbc);
    insetsPanel3.add(yField);


    distanceField = new TextField(""+c.distance, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(distanceLabel, gbc);
    insetsPanel3.add(distanceLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(distanceField, gbc);
    insetsPanel3.add(distanceField);

    bandwidthField = new TextField(""+c.bandwidth, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(bandwidthLabel, gbc);
    insetsPanel3.add(bandwidthLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(bandwidthField, gbc);
    insetsPanel3.add(bandwidthField);

    n1Field = new Label(c.n1.name);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(n1Label, gbc);
    insetsPanel3.add(n1Label);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(n1Field, gbc);
    insetsPanel3.add(n1Field);

    n2Field = new Label(c.n2.name);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(n2Label, gbc);
    insetsPanel3.add(n2Label);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(n2Field, gbc);
    insetsPanel3.add(n2Field);


    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep2, gbc);
    insetsPanel3.add(sep2);

    gbc.anchor = GridBagConstraints.SOUTH;
    Label statusBarLabel = new Label("status:");
    gbc.gridwidth = 1;
    gbl.setConstraints(statusBarLabel, gbc);
    insetsPanel3.add(statusBarLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(statusBar, gbc);
    insetsPanel3.add(statusBar);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep3, gbc);
    insetsPanel3.add(sep3);

    panel3.add(insetsPanel3,BorderLayout.CENTER);
    panel1.add(panel3, BorderLayout.CENTER);
    this.add(panel1, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }
  boolean update() {
    String ns = nameField.getText();
    cl.name = ns;
    ns = xField.getText();
    cl.x = Integer.parseInt(ns);
    ns = yField.getText();
    cl.y = Integer.parseInt(ns);

    try {
      ns = distanceField.getText();
      Double r = Double.valueOf(ns);
      cl.distance = r.doubleValue();
      ns = bandwidthField.getText();
      r = Double.valueOf(ns);
      cl.bandwidth = r.doubleValue();     
    } catch (NumberFormatException e) {
      statusBar.setText("Could not convert string to double/int. ");
      return false;
    }
    return true;
    //System.out.println("update Cable property, get new name="+newName);
  }
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == button1) {
      if (update()) cancel();
    }
    if (e.getSource() == button2) {
      cancel();
    }
  }
}

