//File:         ClientProperty.java
//Project:      ProbeSim
//Version:      0.2
//Designer:     C. Edward Chow
//Revision:
//              1/14/2000  C. Edward Chow
//Bug Report:   send to chow@cs.uccs.edu
//Description:  Simulator for Internet Network Probing Research
//              Dialog Window class for specifying Property of Clients
//

package NetLayout;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ClientProperty extends Dialog implements ActionListener {
  final static int size = 30;
  Node n;
  Client cl;
  NetLayoutFrame f;
  JPanel panel1 = new JPanel();
  //JPanel panel2 = new JPanel();
  JPanel panel3 = new JPanel();
  JPanel insetsPanel1 = new JPanel();
  //JPanel insetsPanel2 = new JPanel();
  JPanel insetsPanel3 = new JPanel();
  JSeparator sep1 = new JSeparator();
  JSeparator sep2 = new JSeparator();
  JSeparator sep3 = new JSeparator();
  Label statusBar = new Label();

  JButton button1 = new JButton();
  JButton button2 = new JButton();
  JLabel label1 = new JLabel();
  JLabel label2 = new JLabel();
  Label nameLabel = new Label("Name:", Label.RIGHT);
  TextField nameField;
  Label idLabel = new Label("ID:", Label.RIGHT);
  Label idField; // change not allowed
  Label xLabel = new Label("X:", Label.RIGHT);
  TextField xField;
  Label yLabel = new Label("Y:", Label.RIGHT);
  TextField yField;
  Label tfLabel = new Label("TraceFile:", Label.RIGHT);
  TextField tfField;
  Label dnsLabel = new Label("DNS Server Name:", Label.RIGHT);
  TextField dnsField;
  Label cacheServerLabel = new Label("Cache Server Name:", Label.RIGHT);
  TextField cacheServerField;
  Label lbaLabel = new Label("LBA Server Name:", Label.RIGHT);
  TextField lbaField;
  Label lonLabel = new Label("Longitude:", Label.RIGHT);
  TextField lonField;
  Label latLabel = new Label("Latitude:", Label.RIGHT);
  TextField latField;
  Label powerLabel = new Label("Power:", Label.RIGHT);
  TextField powerField;
  Label reqIDTavgLabel = new Label("Request Interarrival Time Avg:", Label.RIGHT);
  TextField reqIDTavgField;
  Label reqIDTminLabel = new Label("Request Interarrival Time Min:", Label.RIGHT);
  TextField reqIDTminField;
  Label reqIDTmaxLabel = new Label("Request Interarrival Time Max:", Label.RIGHT);
  TextField reqIDTmaxField;
  Label reqIDTdistLabel = new Label("Request Interarrival Time Distribution Type:", Label.RIGHT);
  TextField reqIDTdistField;
  Label reqDocavgLabel = new Label("Request Msg Size Avg:", Label.RIGHT);
  TextField reqDocavgField;
  Label reqDocminLabel = new Label("Request Msg Size Min:", Label.RIGHT);
  TextField reqDocminField;
  Label reqDocmaxLabel = new Label("Request Msg Size Max:", Label.RIGHT);
  TextField reqDocmaxField;
  Label reqDocdistLabel = new Label("Request Msg Size Distribution Type:", Label.RIGHT);
  TextField reqDocdistField;
  Label linkListLabel = new Label("Connected to:", Label.RIGHT);
  Label linkListField;

  BorderLayout borderLayout1 = new BorderLayout();
  //BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  //FlowLayout flowLayout2 = new FlowLayout();
  //GridLayout gridLayout1 = new GridLayout();
  String product = "Network Layout Tool Copyright (c) 1998";
  String dialogName = "Client Property";

  public ClientProperty(Frame parent, Client c) {
    super(parent);
    f = (NetLayoutFrame) parent;

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit(c);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    pack();
  }

  private void jbInit(Client c) throws Exception  {
    this.setTitle("Client Property");
    cl = c;
    setResizable(false);
    panel1.setLayout(borderLayout1);
    //panel2.setLayout(borderLayout2);
    panel3.setLayout(borderLayout3);
    insetsPanel1.setLayout(flowLayout1);
    //insetsPanel1.setBevelInner(JPanel.RAISED);
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();
    insetsPanel3.setLayout(gbl);
    //insetsPanel3.setBevelInner(JPanel.RAISED);
    //gridLayout1.setRows(4);
    //gridLayout1.setColumns(1);
    label1.setText(product);
    label2.setText(dialogName);
    //insetsPanel2.setLayout(gridLayout1);
    //insetsPanel2.setLayout(borderLayout1);
    //insetsPanel2.setMargins(new Insets(10, 60, 10, 10));
    //insetsPanel2.setBevelInner(JPanel.FLAT);
    //insetsPanel2.add(label1, null);
    //insetsPanel2.add(label2, null);
    //panel2.add(insetsPanel2, BorderLayout.CENTER);
    //panel1.add(panel2, BorderLayout.NORTH);
    button1.setText("UPDATE");
    button1.addActionListener(this);
    button2.setText("CANCEL");
    button2.addActionListener(this);
    insetsPanel1.add(button1, null);
    insetsPanel1.add(button2, null);
    panel1.add(insetsPanel1, BorderLayout.SOUTH);


    gbc.anchor = GridBagConstraints.CENTER;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(label1, gbc);
    insetsPanel3.add(label1);
    
    gbc.anchor = GridBagConstraints.CENTER;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(label2, gbc);
    insetsPanel3.add(label2);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep1, gbc);
    insetsPanel3.add(sep1);
    gbc.fill = 0;

    // add code to create name value pair for each property item
    nameField = new TextField(c.name, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(nameLabel, gbc);
    insetsPanel3.add(nameLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(nameField, gbc);
    insetsPanel3.add(nameField);
    
    idField = new Label(Integer.toString(c.ID),Label.LEFT);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(idLabel, gbc);
    insetsPanel3.add(idLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(idField, gbc);
    insetsPanel3.add(idField);

    xField = new TextField(Integer.toString(c.x), size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(xLabel, gbc);
    insetsPanel3.add(xLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(xField, gbc);
    insetsPanel3.add(xField);

    yField = new TextField(Integer.toString(c.y), size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(yLabel, gbc);
    insetsPanel3.add(yLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(yField, gbc);
    insetsPanel3.add(yField);

    tfField = new TextField(c.traceFile, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(tfLabel, gbc);
    insetsPanel3.add(tfLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(tfField, gbc);
    insetsPanel3.add(tfField);

    n = c.net.searchNode(c.dnsID);
    if (n == null) dnsField = new TextField("", size);
    else  dnsField = new TextField(n.name, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(dnsLabel, gbc);
    insetsPanel3.add(dnsLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(dnsField, gbc);
    insetsPanel3.add(dnsField);

    Node n = c.net.searchNode(c.cacheServerID);
    if (n == null) cacheServerField = new TextField("", size);
    else  cacheServerField = new TextField(n.name, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(cacheServerLabel, gbc);
    insetsPanel3.add(cacheServerLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(cacheServerField, gbc);
    insetsPanel3.add(cacheServerField);

    n = c.net.searchNode(c.lbaID);
    if (n == null) lbaField = new TextField("", size);
    else  lbaField = new TextField(n.name, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(lbaLabel, gbc);
    insetsPanel3.add(lbaLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(lbaField, gbc);
    insetsPanel3.add(lbaField);

    lonField = new TextField(""+c.lon, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(lonLabel, gbc);
    insetsPanel3.add(lonLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(lonField, gbc);
    insetsPanel3.add(lonField);

    latField = new TextField(""+c.lat, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(latLabel, gbc);
    insetsPanel3.add(latLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(latField, gbc);
    insetsPanel3.add(latField);

    powerField = new TextField(""+c.power, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(powerLabel, gbc);
    insetsPanel3.add(powerLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(powerField, gbc);
    insetsPanel3.add(powerField);

    reqIDTavgField = new TextField(""+c.reqIDTSt.avg, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(reqIDTavgLabel, gbc);
    insetsPanel3.add(reqIDTavgLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(reqIDTavgField, gbc);
    insetsPanel3.add(reqIDTavgField);

    reqIDTminField = new TextField(""+c.reqIDTSt.min, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(reqIDTminLabel, gbc);
    insetsPanel3.add(reqIDTminLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(reqIDTminField, gbc);
    insetsPanel3.add(reqIDTminField);

    reqIDTmaxField = new TextField(""+c.reqIDTSt.max, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(reqIDTmaxLabel, gbc);
    insetsPanel3.add(reqIDTmaxLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(reqIDTmaxField, gbc);
    insetsPanel3.add(reqIDTmaxField);

    reqIDTdistField = new TextField(""+c.reqIDTSt.distType, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(reqIDTdistLabel, gbc);
    insetsPanel3.add(reqIDTdistLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(reqIDTdistField, gbc);
    insetsPanel3.add(reqIDTdistField);

    reqDocavgField = new TextField(""+c.reqDocSt.avg, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(reqDocavgLabel, gbc);
    insetsPanel3.add(reqDocavgLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(reqDocavgField, gbc);
    insetsPanel3.add(reqDocavgField);

    reqDocminField = new TextField(""+c.reqDocSt.min, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(reqDocminLabel, gbc);
    insetsPanel3.add(reqDocminLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(reqDocminField, gbc);
    insetsPanel3.add(reqDocminField);

    reqDocmaxField = new TextField(""+c.reqDocSt.max, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(reqDocmaxLabel, gbc);
    insetsPanel3.add(reqDocmaxLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(reqDocmaxField, gbc);
    insetsPanel3.add(reqDocmaxField);

    reqDocdistField = new TextField(""+c.reqDocSt.distType, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(reqDocdistLabel, gbc);
    insetsPanel3.add(reqDocdistLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(reqDocdistField, gbc);
    insetsPanel3.add(reqDocdistField);

    linkListField = new Label(c.linkListNameToString(), Label.LEFT);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(linkListLabel, gbc);
    insetsPanel3.add(linkListLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(linkListField, gbc);
    insetsPanel3.add(linkListField);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep2, gbc);
    insetsPanel3.add(sep2);

    gbc.anchor = GridBagConstraints.SOUTH;
    Label statusBarLabel = new Label("status:");
    gbc.gridwidth = 1;
    gbl.setConstraints(statusBarLabel, gbc);
    insetsPanel3.add(statusBarLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(statusBar, gbc);
    insetsPanel3.add(statusBar);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep3, gbc);
    insetsPanel3.add(sep3);
    
    panel3.add(insetsPanel3,BorderLayout.CENTER);
    panel1.add(panel3, BorderLayout.CENTER);
    this.add(panel1, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }
  boolean update() {
    String ns = nameField.getText();
    cl.name = ns;
    ns = xField.getText();
    cl.x = Integer.parseInt(ns);
    ns = yField.getText();
    cl.y = Integer.parseInt(ns);
    ns = tfField.getText();
    cl.traceFile = ns;

    ns = dnsField.getText();
    int id = cl.net.getID(ns);
    if (id == Net.NOTFOUND) {
      statusBar.setText("The DNS="+ns+" not exist. Check again.");
      return false;
    }
    cl.dnsID = id;

    ns = cacheServerField.getText();
    id = cl.net.getID(ns);
    if (id == Net.NOTFOUND) {
      statusBar.setText("The cache server="+ns+" not exist. Check again.");
      return false;
    }
    cl.cacheServerID = id;
    
    ns = lbaField.getText();
    id = cl.net.getID(ns);
    if (id == Net.NOTFOUND) {
      statusBar.setText("The LBA="+ns+" not exist. Check again.");
      return false;
    }
    cl.lbaID = id;

    try {
      ns = lonField.getText();
      Double r = Double.valueOf(ns);
      cl.lon = r.doubleValue();
      ns = latField.getText();
      r = Double.valueOf(ns);
      cl.lat = r.doubleValue();
      ns = powerField.getText();
      r = Double.valueOf(ns);
      cl.power = r.doubleValue();
      ns = reqIDTavgField.getText();
      r = Double.valueOf(ns);
      cl.reqIDTSt.avg = r.doubleValue();
      ns = reqIDTminField.getText();
      r = Double.valueOf(ns);
      cl.reqIDTSt.min = r.doubleValue();
      ns = reqIDTmaxField.getText();
      r = Double.valueOf(ns);
      cl.reqIDTSt.max = r.doubleValue();
      ns = reqIDTdistField.getText();
      id = Integer.parseInt(ns);
      cl.reqIDTSt.distType = id;
      
      ns = reqDocavgField.getText();
      r = Double.valueOf(ns);
      cl.reqDocSt.avg = r.doubleValue();
      ns = reqDocminField.getText();
      r = Double.valueOf(ns);
      cl.reqDocSt.min = r.doubleValue();
      ns = reqDocmaxField.getText();
      r = Double.valueOf(ns);
      cl.reqDocSt.max = r.doubleValue();
      ns = reqDocdistField.getText();
      id = Integer.parseInt(ns);
      cl.reqDocSt.distType = id;
    } catch (NumberFormatException e) {
      statusBar.setText("Could not convert string to double/int. ");
      return false;
    }
    f.mapArea.redo();
    return true;
    //System.out.println("update client property, get new name="+newName);
  }
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == button1) {
      if (update()) cancel();
    }
    if (e.getSource() == button2) {
      cancel();
    }
  }
}

