//File:         EventRecord.java
//Project:      ProbeSim
//Version:      0.2
//Designer:     C. Edward Chow
//Revision:
//              1/14/2000  C. Edward Chow
//Bug Report:   send to chow@cs.uccs.edu
//Description:  Simulator for Internet Network Probing Research
//              EventRecord class for Discete Event Queue
//              Instances are inserted into EventList
//              msg stores key value pairs
//

package NetLayout;
import java.util.*;

public class EventRecord {
  public double time;
  public int next, src, dst;
  Hashtable msg;
  public EventRecord(){
  }
  public EventRecord(double time, int next, int src, int dst) {
    this.time = time;
    this.next = next;
    this.src = src;
    this.dst = dst;
    msg = new Hashtable();
  }
  public void addField(String key, String value) {
    msg.put(key, value);  // actually the value field can be an object
  }
  public String getField(String key) {
    return (String) msg.get(key);
  }
  public void setNext(int next) {
    this.next = next;
  }
  public EventRecord copy() {
    EventRecord newER = new EventRecord(this.time, this.next, this.src, this.dst);
    Enumeration keys = msg.keys();
    while (keys.hasMoreElements()) {
      String key = (String) keys.nextElement();
      String value = getField(key);
      newER.addField(key, value);
    }
    return newER;             
  }
}
