//File:         NetLayoutFrame.java
//Project:      ProbeSim
//Version:      0.2
//Designer:     C. Edward Chow
//Revision:
//              1/14/2000  C. Edward Chow
//Bug Report:   send to chow@cs.uccs.edu
//Description:  Simulator for Internet Network Probing Research
//              Main GUI interface class
//              Contain menus, interaction, network topology editing
//

package NetLayout;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*; // for StringTokenizer and Vector
import java.lang.*;
import javax.swing.*;

public class NetLayoutFrame extends JFrame {

  //Construct the frame
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuBar A = new JMenuBar();
  JMenu menuFile = new JMenu("File");
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu("Help");
  JMenuItem menuHelpAbout = new JMenuItem();
  // ButtonBar toolBar = new ButtonBar();
  //StatusBar statusBar = new StatusBar();
  JTextField statusBar = new JTextField();
  JMenuItem JMenuItem1 = new JMenuItem();
  JMenuItem JMenuItem2 = new JMenuItem();
  JMenuItem JMenuItem3 = new JMenuItem();
  JMenuItem JMenuItem4 = new JMenuItem();
  JMenuItem JMenuItem5 = new JMenuItem();
  JMenuItem JMenuItem6 = new JMenuItem();
  JMenu menu1 = new JMenu();
  JMenu menu2 = new JMenu();
  JMenuItem JMenuItem7 = new JMenuItem();
  JMenuItem JMenuItem8 = new JMenuItem();
  JMenuItem JMenuItem9 = new JMenuItem();
  JMenuItem JMenuItem10 = new JMenuItem();
  JMenuItem JMenuItem11 = new JMenuItem();
  JMenuItem JMenuItem12 = new JMenuItem();
  JMenuItem JMenuItem13 = new JMenuItem();
  JMenuItem JMenuItem14 = new JMenuItem();
  JMenuItem JMenuItem15 = new JMenuItem();
  JMenuItem JMenuItem16 = new JMenuItem();
  JMenuItem JMenuItem17 = new JMenuItem();
  JMenuItem JMenuItem18 = new JMenuItem();
  JMenuItem JMenuItem19 = new JMenuItem();
  JMenuItem JMenuItem20 = new JMenuItem();
  JMenuItem JMenuItem21 = new JMenuItem();
  JMenuItem JMenuItem22 = new JMenuItem();
  JMenuItem JMenuItem23 = new JMenuItem();
  JMenuItem JMenuItem24 = new JMenuItem();

  Net net = new Net(this, "net1");
  MapArea mapArea = new MapArea(net);

  final static int CLIENT = 1;
  final static int SERVER = 2;
  final static int CACHE = 3;
  final static int DNS = 4;
  final static int LBA = 5;
  final static int ROUTER = 6;
  final static int SWITCH = 7;
  final static int PROBE = 8;
  final static int PROBERCV = 9;
  final static int NoOfNodeTypes = 9;

  final static int PTPLINK = 10;
  final static int MALINK = 11;
  final static int CABLE = 12;

  final static int NoOfObjects = 12;

  Image[] im = new Image[NoOfNodeTypes+1]; // there are six images select.jpg, client.jpg, server.jpg
  //  cache.jpg, dns.jpg, lba.jpg, router.jpg, switch.jpg,
  //  probe.jpg, probeRcv.jpg

  
  int placeComponent;
  int firstx, firsty, secondx, secondy;
  int smallx, smally;
  int width, height;     
  Node firstNode;
  Node secondNode;
  Node selectedNode;
  Link selectedLink;
  MALink selectedMALink;
  MALink maLink;
  JMenuItem JMenuItem25 = new JMenuItem();
  JMenuItem JMenuItem26 = new JMenuItem();
  JMenuItem JMenuItem27 = new JMenuItem();
  // Filer filer1 = new Filer();
  FileDialog filer1 = new FileDialog(this, "File Chooser");
  // private JFileChooser filer1 = new JFileChooser();
  String currFileName = null;  // path plus filename. null means new / untitled
  boolean dirty = false;  // true means modified text
  DataInputStream in;
  JMenuItem JMenuItem28 = new JMenuItem();
  JMenuItem JMenuItem29 = new JMenuItem();
  JMenuItem JMenuItem30 = new JMenuItem();
  JMenu menu3 = new JMenu();
  JMenuItem JMenuItem31 = new JMenuItem();
  JMenuItem JMenuItem35 = new JMenuItem();
  JMenu menu4 = new JMenu();
  JMenuItem JMenuItem32 = new JMenuItem();
  JMenuItem JMenuItem33 = new JMenuItem();
  JMenuItem JMenuItem34 = new JMenuItem();
  boolean animation_on = false;



  public NetLayoutFrame() {
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
//Component initialization
  
  private void jbInit() throws Exception  {
    //this.getContentPane().add(child);
    //this.getContentPane().setLayout(borderLayout1);
    //this.getContentPane().setPreferredSize(new Dimension(400, 300));
    JPanel contentPane = new JPanel();
    contentPane.setLayout(new BorderLayout());
    contentPane.setPreferredSize(new Dimension(400, 300));
    JScrollPane scrollPane1 = new JScrollPane(mapArea);
    contentPane.add(scrollPane1, BorderLayout.CENTER);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    setContentPane(contentPane);
    this.setTitle("ProbeSim: Simulator for Internet Available Bandwidth Probing Research");
    menuFile.setLabel("File");
    menuFileExit.setLabel("Exit");
    menuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setLabel("Help");
    menuHelpAbout.setLabel("About");
    menuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    // toolBar.setButtonType(ButtonBar.IMAGE_ONLY);
    // toolBar.setLabels(new String[] {"File", "Close", "Help"});
    JMenuItem1.setLabel("New");
    JMenuItem1.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,KeyEvent.CTRL_MASK));

    JMenuItem2.setLabel("Open");
    JMenuItem2.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,KeyEvent.CTRL_MASK));
    JMenuItem2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem2_actionPerformed(e);
      }
    });
    JMenuItem3.setLabel("Close");
    JMenuItem4.setLabel("Save");
    JMenuItem4.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,KeyEvent.CTRL_MASK));
    JMenuItem4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem4_actionPerformed(e);
      }
    });
    JMenuItem5.setLabel("Save As");
    JMenuItem5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem5_actionPerformed(e);
      }
    });
    JMenuItem6.setLabel("Print");
    JMenuItem6.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,KeyEvent.CTRL_MASK));
    menu1.setLabel("Component");
    menu2.setLabel("Edit");
    JMenuItem7.setLabel("Undo");
    JMenuItem7.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_U,KeyEvent.CTRL_MASK));
    JMenuItem8.setLabel("Redo");
    JMenuItem8.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_U,KeyEvent.CTRL_MASK | KeyEvent.SHIFT_MASK));
    JMenuItem9.setLabel("Cut");
    JMenuItem9.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,KeyEvent.CTRL_MASK));
    JMenuItem9.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem9_actionPerformed(e);
      }
    });
    JMenuItem10.setLabel("Copy");
    JMenuItem10.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,KeyEvent.CTRL_MASK));
    JMenuItem11.setLabel("Paste");
    JMenuItem11.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V,KeyEvent.CTRL_MASK));
    JMenuItem12.setLabel("Duplicate");
    JMenuItem12.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D,KeyEvent.CTRL_MASK));
    JMenuItem13.setLabel("Delete");
    JMenuItem14.setLabel("Select All");
    JMenuItem14.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,KeyEvent.CTRL_MASK));
    JMenuItem15.setLabel("Find");
    JMenuItem15.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F,KeyEvent.CTRL_MASK));
    JMenuItem16.setLabel("Replace");
    JMenuItem16.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,KeyEvent.CTRL_MASK));
    JMenuItem17.setLabel("Zoom");
    JMenuItem17.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,KeyEvent.CTRL_MASK));
    JMenuItem18.setLabel("Client");
    JMenuItem18.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem18_actionPerformed(e);
      }
    });
    JMenuItem19.setLabel("Server");
    JMenuItem19.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem19_actionPerformed(e);
      }
    });
    JMenuItem20.setLabel("DNS");
    JMenuItem20.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem20_actionPerformed(e);
      }
    });
    JMenuItem21.setLabel("LBA");
    JMenuItem21.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem21_actionPerformed(e);
      }
    });
    JMenuItem22.setLabel("Router");
    JMenuItem22.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem22_actionPerformed(e);
      }
    });
    JMenuItem23.setLabel("p-t-p Link");
    JMenuItem23.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem23_actionPerformed(e);
      }
    });
    JMenuItem24.setLabel("PlaceMALink");
    mapArea.setBounds(new Rectangle(0, 0, 600, 400));
    JMenuItem25.setLabel("Select");
    JMenuItem26.setLabel("ConnectMALink/Router/Switch");
    JMenuItem27.setLabel("Redisplay");
    JMenuItem27.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R, KeyEvent.CTRL_MASK));
    //filer1.setFrame(this);
    JMenuItem28.setLabel("Property");
    JMenuItem28.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P, KeyEvent.CTRL_MASK | KeyEvent.SHIFT_MASK));
    JMenuItem29.setLabel("Switch");
    JMenuItem30.setLabel("CacheServer");
    JMenuItem33.setLabel("ProbingAgent");
    JMenuItem34.setLabel("ProbingResponder");

    menu3.setLabel("Simulation");
    JMenuItem35.setLabel("Set Simulation Control");
    JMenuItem35.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, KeyEvent.CTRL_MASK | KeyEvent.SHIFT_MASK));
    JMenuItem31.setLabel("Start Simulation");
    JMenuItem31.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, KeyEvent.CTRL_MASK | KeyEvent.SHIFT_MASK));


    menu4.setLabel("Animation");
    JMenuItem32.setLabel("Start Animation ");
    JMenuItem32.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, KeyEvent.CTRL_MASK | KeyEvent.SHIFT_MASK));

    JMenuItem35.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem35_actionPerformed(e);
      }
    });


    JMenuItem34.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem34_actionPerformed(e);
      }
    });
    JMenuItem33.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem33_actionPerformed(e);
      }
    });

    JMenuItem32.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem32_actionPerformed(e);
      }
    });
    JMenuItem31.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem31_actionPerformed(e);
      }
    });

    JMenuItem30.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem30_actionPerformed(e);
      }
    });
    JMenuItem29.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem29_actionPerformed(e);
      }
    });
    JMenuItem28.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem28_actionPerformed(e);
      }
    });
    JMenuItem27.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem27_actionPerformed(e);
      }
    });
    JMenuItem26.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem26_actionPerformed(e);
      }
    });
    JMenuItem25.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem25_actionPerformed(e);
      }
    });
    mapArea.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        mapArea_mousePressed(e);
      }
    });
    JMenuItem24.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        JMenuItem24_actionPerformed(e);
      }
    });
    //toolBar.setImageBase("image");
    //toolBar.setImageNames(new String[] {"openFile.gif", "closeFile.gif", "help.gif"});
    menuFile.add(JMenuItem1);
    menuFile.add(JMenuItem2);
    menuFile.add(JMenuItem3);
    menuFile.addSeparator();
    menuFile.add(JMenuItem4);
    menuFile.add(JMenuItem5);
    menuFile.addSeparator();
    menuFile.add(JMenuItem6);
    menuFile.addSeparator();
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    A.add(menuFile);
    A.add(menu2);
    A.add(menu1);
    A.add(menu4);
    A.add(menu3);
    A.add(menuHelp);
    this.setJMenuBar(A);

    menu2.add(JMenuItem7);
    menu2.add(JMenuItem8);
    menu2.addSeparator();
    menu2.add(JMenuItem28);
    menu2.addSeparator();
    menu2.add(JMenuItem9);
    menu2.add(JMenuItem10);
    menu2.add(JMenuItem11);
    menu2.add(JMenuItem12);
    menu2.add(JMenuItem13);
    menu2.addSeparator();
    menu2.add(JMenuItem14);
    menu2.addSeparator();
    menu2.add(JMenuItem15);
    menu2.add(JMenuItem16);
    menu2.addSeparator();
    menu2.add(JMenuItem17);
    menu2.add(JMenuItem27);
    menu1.add(JMenuItem25);
    menu1.addSeparator();
    menu1.add(JMenuItem18);
    menu1.add(JMenuItem19);
    menu1.add(JMenuItem30);
    menu1.add(JMenuItem20);
    menu1.add(JMenuItem21);
    menu1.add(JMenuItem22);
    menu1.add(JMenuItem29);
    menu1.add(JMenuItem33);
    menu1.add(JMenuItem34);

    menu1.addSeparator();
    menu1.add(JMenuItem23);
    menu1.add(JMenuItem24);
    menu1.add(JMenuItem26);

    menu3.add(JMenuItem35);
    menu3.add(JMenuItem31);

    menu4.add(JMenuItem32);
    //this.getContentPane().add(toolBar, BorderLayout.NORTH);



    im[0] = Toolkit.getDefaultToolkit().getImage("select.jpg");
    im[CLIENT] = Toolkit.getDefaultToolkit().getImage("client.jpg");
    im[SERVER] = Toolkit.getDefaultToolkit().getImage("server.jpg");
    im[CACHE] = Toolkit.getDefaultToolkit().getImage("cache.jpg");
    im[DNS] = Toolkit.getDefaultToolkit().getImage("dns.jpg");
    im[LBA] = Toolkit.getDefaultToolkit().getImage("lba.jpg");
    im[ROUTER] = Toolkit.getDefaultToolkit().getImage("router.jpg");
    im[SWITCH] = Toolkit.getDefaultToolkit().getImage("switch.jpg");
    im[PROBE] =  Toolkit.getDefaultToolkit().getImage("probe.jpg");
    im[PROBERCV] =  Toolkit.getDefaultToolkit().getImage("probeRcv.jpg");
    MediaTracker tracker = new MediaTracker(this);
    for (int i = 0; i <= NoOfNodeTypes; i++) {
      tracker.addImage(im[i], 1);
    }
    try {
      tracker.waitForAll();
    } catch (InterruptedException e) {
      return;
    }
  }

  /**
    * Open named file; read network data from file  create
    * network components ; report to statusBar.
    * @param fileName the name of the network file on disk
    */
   void openFile(String fileName)
   {
     try
     {
       // Open a file of the given name.
       in = new DataInputStream(new FileInputStream(fileName));

       // read, parse, and rescontruct network components
       if (!net.reconstruct(in)) {
        statusBar.setText("reconstruct net "+fileName+" failed!");
       }

       // Cache the currently opened filename for use at save time...
       this.currFileName = fileName;

       net.fileName = extractFileName(fileName);
       // ...and mark the edit session as being clean.
       this.dirty = false;

    
       // Display the name of the opened directory+file in the statusBar.
       statusBar.setText("Opened "+fileName);
     }
     catch (IOException e)
     {
       statusBar.setText("Error opening "+fileName);
     }
   }

   String extractFileName(String fileName) {
      // remove the path and extension
      int endChar=fileName.length()-1;
      int startChar=0;
      for (int i=fileName.length()-1; i>=0; i--) {
         if (fileName.charAt(i) == '.') endChar=i;
         if (fileName.charAt(i) == '\\') {
            startChar=i+1; // need port to Unix?
            return fileName.substring(startChar, endChar);
         }
      }
      return null;
   }

   /**
    * Save current file; handle not yet having a filename; report to statusBar.
    * @return false if save did not occur.
    */
   boolean saveFile()
   {
    
     // Handle the case where we don't have a file name yet.
     if (currFileName == null) {
       return saveAsFile();
     }
    
     try
     {
       // Open a file of the current name.
       File file = new File (currFileName);
    
       // Create an output writer that will write to that file.
       // FileWriter handles international characters encoding conversions.
       FileWriter out = new FileWriter(file);

       out.write(net.toString());
       out.close();
       this.dirty = false;
       return true;
     }
     catch (IOException e) {
       statusBar.setText("Error saving "+currFileName);
     }
     return false;
   }
    
      /**
    * Save current file, asking user for new destination name.
    * Report to statuBar.
    * @return false means user cancelled the SaveAs
    */
   boolean saveAsFile() {

     // Filer makes use of a java.awt.FileDialog, so its
     // mode property uses the same values as those of FileDialog.
     filer1.setMode(FileDialog.SAVE); // Use the SAVE version of the dialog.
    
     // Make the dialog visible as a modal (default) dialog box.
     filer1.show();
    
     // Upon return, getFile() will be null if user cancelled the dialog.
     if (filer1.getFile() != null) {
       // Non-null file property after return implies user
       // selected a filename to save to.
    
       // Set the current file name to the user's selection,
       // then do a regular saveFile.
       currFileName = filer1.getDirectory()+filer1.getFile();
       return saveFile();
     }
     else {
       return false;
     }
   }


//File | Exit action performed

  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
//Help | About action performed
  
  public void helpAbout_actionPerformed(ActionEvent e) {
    NetLayoutFrame_AboutBox dlg = new NetLayoutFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  void JMenuItem18_actionPerformed(ActionEvent e) {
    statusBar.setText("Client selected. Click the location of the client.");
    placeComponent = CLIENT;
  }

  void JMenuItem19_actionPerformed(ActionEvent e) {
    statusBar.setText("Server selected. Click the location of the server.");
    placeComponent = SERVER;
  }

  void JMenuItem20_actionPerformed(ActionEvent e) {
    statusBar.setText("DNS selected. Click the location of the DNS server.");
    placeComponent = DNS;
  }

  void JMenuItem21_actionPerformed(ActionEvent e) {
    statusBar.setText("LBA selected. Click the location of the LBA.");
    placeComponent = LBA;
  }

  void JMenuItem22_actionPerformed(ActionEvent e) {
    statusBar.setText("Router selected. Click the location of the router.");
    placeComponent = ROUTER;
  }
  void JMenuItem29_actionPerformed(ActionEvent e) {
    statusBar.setText("Switch selected. Click the location of the switch.");
    placeComponent = SWITCH;
  }
  void JMenuItem33_actionPerformed(ActionEvent e) {
    statusBar.setText("ProbingAgent selected. Click the location of the probing agent.");
    placeComponent = PROBE;
  }
  void JMenuItem34_actionPerformed(ActionEvent e) {
    statusBar.setText("ProbingResponder selected. Click the location of the probing responder.");
    placeComponent = PROBERCV;
  }

  void JMenuItem23_actionPerformed(ActionEvent e) {
    statusBar.setText("P-t-p Link selected. Click the end node of the link.");
    placeComponent = PTPLINK;
    firstNode = null;
    secondNode = null;
  }

  void JMenuItem24_actionPerformed(ActionEvent e) {
    statusBar.setText("Place MA Link selected. Click the end points of the link.");
    placeComponent = MALINK;
    firstx = 0;
  }

  void JMenuItem25_actionPerformed(ActionEvent e) {
    statusBar.setText("Select mode chosen. Click the node of interess.");
    placeComponent = 0;
  }

  void JMenuItem26_actionPerformed(ActionEvent e) {
    statusBar.setText("Connect selected. Click the end node of the cable.");
    placeComponent = CABLE;
  }
  void JMenuItem30_actionPerformed(ActionEvent e) {
    statusBar.setText("Cache server selected. Click the location of the cache server.");
    placeComponent = CACHE;
  }
  
  void JMenuItem27_actionPerformed(ActionEvent e) {
    mapArea.repaint();
  }
  void JMenuItem28_actionPerformed(ActionEvent e) {
    if (selectedNode != null) {
      if (selectedNode.getType() == CLIENT) {
        Client cl = net.searchClient(selectedNode.getID());
        ClientProperty dlg = new ClientProperty(this, cl);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();

        dlg.setLocation(loc.x+frmSize.width, loc.y);
        // set dialog window at the right side of the layout window
        // so that we can still see the topology
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        // dlg.setModal(true);
        // set Modal mean 1. block thread execution and input to ancestor windows
        // also the thread that shows the dialog is block unitl the dialog is closed.
        // Here we would like to show or redisplay the topology therefore we do not want modal
        //by default, Model is not set
        dlg.show();
      }
      if (selectedNode.getType() == SERVER) {
        Server s = net.searchServer(selectedNode.getID());
        ServerProperty dlg = new ServerProperty(this, s);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }
      if (selectedNode.getType() == CACHE) {
        CacheServer cs = net.searchCacheServer(selectedNode.getID());
        CacheServerProperty dlg = new CacheServerProperty(this, cs);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }
      if (selectedNode.getType() == DNS) {
        DNS d = net.searchDNS(selectedNode.getID());
        DNSProperty dlg = new DNSProperty(this, d);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }
      if (selectedNode.getType() == LBA) {
        LBA l = net.searchLBA(selectedNode.getID());
        LBAProperty dlg = new LBAProperty(this, l);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }
      if (selectedNode.getType() == ROUTER) {
        Router r = net.searchRouter(selectedNode.getID());
        RouterProperty dlg = new RouterProperty(this, r);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }
      if (selectedNode.getType() == SWITCH) {
        Switch s = net.searchSwitch(selectedNode.getID());
        SwitchProperty dlg = new SwitchProperty(this, s);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }
      if (selectedNode.getType() == PROBE) {
        ProbingAgent p = net.searchProbingAgent(selectedNode.getID());
        ProbingAgentProperty dlg = new ProbingAgentProperty(this, p);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }
      if (selectedNode.getType() == PROBERCV) {
        ProbingResponder pr = net.searchProbingResponder(selectedNode.getID());
        ProbingResponderProperty dlg = new ProbingResponderProperty(this, pr);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }

    } else if (selectedMALink != null) {
        MALinkProperty dlg = new MALinkProperty(this, selectedMALink);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
    } else if (selectedLink != null) {
      if (selectedLink.type == net.CABLE) {
        Cable c = net.searchCable(selectedLink.getID());
        CableProperty dlg = new CableProperty(this, c);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }
      if (selectedLink.type == net.PTPLINK) {
        PTPLink ptpl = net.searchPTPLink(selectedLink.getID());
        PTPLinkProperty dlg = new PTPLinkProperty(this, ptpl);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation(loc.x+frmSize.width, loc.y);
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        //dlg.setModal(true);
        dlg.show();
      }     
    }
  }
  void mapArea_mousePressed(MouseEvent e) {
    statusBar.setText("select the location x="+ e.getX()+ " y="+ e.getY());
    Graphics g = mapArea.getGraphics();
    switch (placeComponent) {
    case 0:
      selectedNode = net.searchNode(e.getX(), e.getY());
      if (selectedNode !=null)
        statusBar.setText("Node "+selectedNode.getName()+" is selected.");
      else {
        selectedLink = net.searchLink(e.getX(), e.getY());
        selectedMALink = null;
        if (selectedLink != null)
          statusBar.setText("Link "+selectedLink.getName()+" is selected.");
        else {
          selectedMALink = net.searchMALink(e.getX(), e.getY());
          if (selectedMALink != null)
            statusBar.setText("MALink "+selectedMALink.getName()+" is selected.");
          else
            statusBar.setText("No component is selected.");
        }
      }
      break;
    case CLIENT:
      Client c = new Client(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[CLIENT], e.getX(), e.getY(), this)) {};
      g.drawString(c.getName(), e.getX(), e.getY()+44);
      break;
    case SERVER:
      Server s = new Server(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[SERVER], e.getX(), e.getY(), this)) {};
      g.drawString(s.getName(), e.getX(), e.getY()+44);
      break;
    case CACHE:
      CacheServer cs = new CacheServer(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[CACHE], e.getX(), e.getY(), this)) {};
      g.drawString(cs.getName(), e.getX(), e.getY()+44);
      break;
    case DNS:
      DNS d = new DNS(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[DNS], e.getX(), e.getY(), this)) {};
      g.drawString(d.getName(), e.getX(), e.getY()+44);
      break;
    case LBA:
      LBA l = new LBA(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[LBA], e.getX(), e.getY(), this)) {};
      g.drawString(l.getName(), e.getX(), e.getY()+44);
      break;
    case ROUTER:
      Router r = new Router(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[ROUTER], e.getX(), e.getY(), this)) {};
      g.drawString(r.getName(), e.getX(), e.getY()+44);
      break;
    case SWITCH:
      Switch sw = new Switch(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[SWITCH], e.getX(), e.getY(), this)) {};
      g.drawString(sw.getName(), e.getX(), e.getY()+44);
      break;
    case PROBE:
      ProbingAgent p = new ProbingAgent(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[PROBE], e.getX(), e.getY(), this)) {};
      g.drawString(p.getName(), e.getX(), e.getY()+44);
      break;
    case PROBERCV:
      ProbingResponder pr = new ProbingResponder(net, e.getX(), e.getY());
      // need while loop unitl the image is complete drawn
      while (!g.drawImage(im[PROBERCV], e.getX(), e.getY(), this)) {};
      g.drawString(pr.getName(), e.getX(), e.getY()+44);
      break;
    case PTPLINK: // p-t-p Link case
      if (firstNode != null) {  // firstNode of the link selected
        secondNode = net.searchNode(e.getX(), e.getY());
        if (secondNode != null) {
          if (secondNode == firstNode) {
            statusBar.setText("The second node of the PTPLink can not be the first node. Try again!");
          } else {
          PTPLink ptpl = new PTPLink(net, firstNode, secondNode);
          g.setColor(Color.red);
          g.drawLine(firstNode.getX()+16, firstNode.getY()+16,
                     secondNode.getX()+16, secondNode.getY()+16);
          statusBar.setText("Create PTPLink="+ptpl.getName());
          firstNode = null;   // reset firstNode to null
          secondNode = null;
          }
        } else {
          statusBar.setText("You have not selected the second node of the link. Try again!");
        }
      } else { // firstNode not selected yet
        firstNode = net.searchNode(e.getX(), e.getY());
        if (firstNode == null) {
          statusBar.setText("You have not selected the first node of the link. Try again!");
        } else {
          statusBar.setText("First Node="+firstNode.getName()+", select 2nd Node.");
        }
      }
      break;
    case MALINK: // Place MA Link case
      if (firstx == 0) {
        firstx = e.getX();
        firsty = e.getY();
      } else {
        secondx = e.getX();
        secondy = e.getY();
        if (firstx > secondx) {
          smallx = secondx;
          width = firstx - secondx;
        } else {
          smallx = firstx;
          width = secondx - firstx;
          if (width == 0) width=1;
        }
        if (firsty > secondy) {
          smally = secondy;
          height = firsty - secondy;
        } else {
          smally = firsty;
          height = secondy - firsty;
          if (height == 0) height=1;
        }
        g.setColor(Color.green);
        g.fillRect(smallx, smally, width, height);
        MALink mal = new MALink(net, smallx, smally, width, height);
        firstx = 0;
      }
      break;
    case CABLE: // Connect to MA Link case
      if (firstNode != null) { // firstNode selected
        maLink = (MALink) net.searchMALink(e.getX(), e.getY());
        if (maLink != null && firstNode != maLink) {
          Cable ca = new Cable(net, firstNode, maLink, e.getX(), e.getY());
          g.setColor(Color.green);
          g.drawLine(firstNode.getX()+16, firstNode.getY()+16,
                     e.getX(), e.getY());
          firstNode = null;   // reset firstNode to null
        } else {                           
          Router ro = net.searchRouter(e.getX(), e.getY());
          if (ro != null && firstNode != ro) {
            Cable ca = new Cable(net, firstNode, ro, ro.getX(), ro.getY());
            g.setColor(Color.green);
            g.drawLine(firstNode.getX()+16, firstNode.getY()+16,
                     ro.getX()+16, ro.getY()+16);
            firstNode = null;   // reset firstNode to null
          } else {
            Switch swi = net.searchSwitch(e.getX(), e.getY());
            if (swi != null && firstNode != swi) {
              Cable ca = new Cable(net, firstNode, swi, swi.getX(), swi.getY());  
              g.setColor(Color.green);
              g.drawLine(firstNode.getX()+16, firstNode.getY()+16,
                     swi.getX()+16, swi.getY()+16);
              firstNode = null;   // reset firstNode to null
            } else {
              statusBar.setText("You have not selected malink/router/switch . Try again!");
            } // end if (sw!=null)
          } // end if (r != null)
        } // end if (malink != null)
      } else { // firstNode not selected yet
        firstNode = net.searchNode(e.getX(), e.getY());
        if (firstNode == null) {
          statusBar.setText("You have not selected the first node of the link. Try again!");  
        } else {
          statusBar.setText("First Node="+firstNode.getName()+", select 2nd Node.");
        }
      }
      break;
    default:
      statusBar.setText("This should not happen!");
      break;
    }
  }

  void JMenuItem2_actionPerformed(ActionEvent e) {

    // The code that use java.awt.FileDialog
    // Handle the File|Open menu item.

     // Filer makes use of a java.awt.FileDialog, and so its
     // mode property uses the same values as those of FileDialog.
     filer1.setMode(FileDialog.LOAD); // Use the OPEN version of the dialog.
    
     // Make the dialog visible as a modal (default) dialog box.
     filer1.show();
    
     // Upon return, getFile() will be null if user cancelled the dialog.
     if (filer1.getFile() != null) {
       // Non-null file property after return implies user
       // selected a file to open.
       currFileName = filer1.getFile();
       // Call openFile to attempt to load the text from file into TextArea
       openFile(filer1.getDirectory()+filer1.getFile());

     }
     /* this code use javax.swing.JFileChooser
     int returnVal = fc.showOpenDialog(this);
     if (returnVal == JFileChooser.APPROVE_OPTION) {
       File file = fc.getSelectedFile();
       openFile(file.getName());
     } else {
       statusBar.setText("Save command cancelled by user.");
     }
     */
  }

  void JMenuItem4_actionPerformed(ActionEvent e) {
    saveFile();
  }

  void JMenuItem5_actionPerformed(ActionEvent e) {
    saveAsFile();
  }

  void JMenuItem9_actionPerformed(ActionEvent e) {

  }

  void JMenuItem31_actionPerformed(ActionEvent e) {
    net.startSimulation();
  }
  void JMenuItem35_actionPerformed(ActionEvent e) {
     SimControlProperty dlg = new SimControlProperty(this, net);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();

        dlg.setLocation(loc.x+frmSize.width, loc.y);
        // set dialog window at the right side of the layout window
        // so that we can still see the topology
        //dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
        // dlg.setModal(true);
        // set Modal mean 1. block thread execution and input to ancestor windows
        // also the thread that shows the dialog is block unitl the dialog is closed.
        // Here we would like to show or redisplay the topology therefore we do not want modal
        //by default, Model is not set
        dlg.show();
  }
  void JMenuItem32_actionPerformed(ActionEvent e) {
    if (animation_on) {
      animation_on=false;
      net.setAnimationOn(false);
      statusBar.setText("turn off animation.");
    } else {
      animation_on=true;
      net.setAnimationOn(true);
      statusBar.setText("turn on animation.");
    }
  }









}


