//File:         Node.java
//Project:      ProbeSim
//Version:      0.2
//Designer:     C. Edward Chow
//Revision:
//              1/14/2000  C. Edward Chow
//Bug Report:   send to chow@cs.uccs.edu
//Description:  Simulator for Internet Network Probing Research
//              Basic class for client, server, cache server, LBA, DNS
//              Probing Agent/Responder, Switch, Router
//

package NetLayout;

import java.awt.*;
import java.util.*; // for StringTokenizer and Vector

public class Node {
  int x, y;
  Net net;
  double lon, lat, power;    
  int type;
  int ID;
  String name = "<unnamed>";
  protected  Vector links = new Vector(2, 2);
  double localTime = 0.0;
  public double totalQueueingTime = 0.0;
  public int noOfRequests = 0;
  public Node() {   // required other the subclass construct will be complianed
                    // for not found this constructor
     lon = 0.0;
     lat = 0.0;
     power = 1.0;
  }
  public Node(Net net, StringTokenizer st, int type) {
    this.type = type;
    this.net = net;
    AttrValue av = new AttrValue(st);
    name = av.value;
    av = new AttrValue(st);
    ID = Integer.parseInt(av.value);
    net.objID++;
    av = new AttrValue(st);
    x = Integer.parseInt(av.value);
    av = new AttrValue(st);
    y = Integer.parseInt(av.value);
    net.nodes.addElement(this);
    //System.out.println(" name="+name+" ID="+ID+" x="+x+" y="+y);                 
  }
  public String toString() {
    return "type="+type+" name="+name+" ID="+ID+
      " x="+x+" y="+y+linkListToString()+"\n";
  }
  public String linkListToString() {
    String list = " LinkList=[";
    if (links.size() == 0) return list += "]";
    for (int i=0; i<links.size(); i++) {
      Link l = (Link) links.elementAt(i);
      if (i==links.size()-1) list += l.ID + "]";
      else list += l.ID + ",";
    }
    return list;
  }
  public String linkListNameToString() {
    String list = "[";
    for (int i=0; i<links.size(); i++) {
      Link l = (Link) links.elementAt(i);
      if (i==links.size()-1) list += l.name + "]";
      else list += l.name + ",";
    }
    return list;
  }
  public Link getFirstLink() {
    return (Link) links.elementAt(0);
  }
  public Net getNet() {
    return net;
  }
  public int getID() {
    return ID;
  }
  public int getX() {
    return x;
  }
  public int getY() {
    return y;
  }
  public int getType() {
    return type;
  }
  public String getName() {
    return name;
  }
  public void addLink(Link l){
    links.addElement(l);
  }
  
  public boolean inNode(int x, int y) {
    if ((x > this.x && x < this.x + 31) && (y > this.y && y < this.y +31)) {
      return true;
    } else {
      return false;
    }
  }
}
