
/**
 * Title:        NetLayout0.3<p>
 * Description:  NetLayout0.3 with bottleneck detection<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      UCCS<p>
 * @author Edward Chow
 * @version
 */
package NetLayout;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.text.*;


class PlotIterationPanel_1 extends Panel  {
   ProbingAgent pa;
   int firstX;
   int firstY;
   int startTime;
   int endTime;
   double[] sendingTime;
   double[] receivingTime;

   public double max(double x, double y)  {
      if(x > y)
         return x;
      else
         return y;
   }

   public PlotIterationPanel_1(ProbingAgent p, Point location)  {
      pa = p;
      firstX = (int) location.getX();
      firstY = (int) location.getY();
//      System.out.println("Sending Time is"+pa.sendingTime[1]);
//      System.out.println("Ending Time is"+pa.receivingTime[pa.noOfMsgs]);
      startTime =  (int) (pa.sendingTime[1]*1000000);
 //     endTime =  (int) ( max( 1000000*( pa.receivingTime[pa.noOfMsgs]-(pa.receivingTime[1]-pa.sendingTime[1]) ), pa.sendingTime[10]*1000000 ) );
      endTime = (int) (pa.receivingTime[pa.noOfMsgs]*1000000 + 1 );
      System.out.println("startTime="+startTime);
      System.out.println("endTime"+endTime);
      sendingTime = new double[pa.noOfMsgs+1];
      receivingTime = new double[pa.noOfMsgs+1];

      int i;
      for(i=1; i<=pa.noOfMsgs; i++) {
         sendingTime[i] = pa.sendingTime[i];
         receivingTime[i] = pa.receivingTime[i];
      }
    /*
      String title="Round="+pa.net.probingRound+",Iteration="+pa.iteration+"";
      Label titleLabel = new Label(title);
      add(titleLabel);
    */

   }


   public int getX(int msgNo)  {
      int x = 70+58*(msgNo-1);
      System.out.println("X="+x);
      return 70+58*(msgNo-1);
   }

   public int getY(double time)  {
      double timePerPixel = (endTime - startTime)/400;

 //     System.out.println("timePerPixel=" +timePerPixel);
      System.out.println("Time="+time);
      int y =  430 - (int) ((time*1000000 - startTime)/timePerPixel);
      System.out.println("Y="+y);
      return y;
   }

   public void update(Graphics g)  {
      paint(g);
   }

   public void paint(Graphics g)  {
//      public void drawing()  {

 //     Graphics g = this.getGraphics();

      g.drawRect(70, 30, 580, 400);

      int timeRange = endTime - startTime;
      double msPerTick = timeRange/10;
      String timeUnit = "ms";

       for (int i=0; i<=10; i++)  {
            double timeLabel = startTime+msPerTick*i;
            DecimalFormat doubleDF = new DecimalFormat("####.###");
            String label = doubleDF.format(timeLabel)+timeUnit;
            g.drawString(label, 5, 430-i*40);
       }

       for (int i=1; i<10; i++)  {
            DecimalFormat intDF = new DecimalFormat("##");
            int msgNo= i;
            String label = intDF.format(msgNo);
            g.drawString(label, 70+(i-1)*58, 450);
       }

       int lastx = 70;
       int lasty = 430;
       for (int i=1; i<=10; i++)  {
          int x = getX(i);
          int y = getY(sendingTime[i]);
          System.out.println("This dot should be put to pixel"+y);
          g.setColor(Color.blue);
          g.drawLine(lastx, lasty, x, y);
          g.drawRect(x-2, y-2, 4, 4);
          g.fillRect(x-2, y-2, 4, 4);
          lastx=x; lasty=y;
         }

        lastx = 70;
        lasty = 430;
        for (int i=1; i<=10; i++)  {
            int x = getX(i);
            int y = getY(receivingTime[i]-(receivingTime[1]-sendingTime[1]));
    //        int y = getY(receivingTime[i]);
            System.out.println("This dot should be put to pixel"+y);
            g.setColor(Color.red);
            g.drawLine(lastx, lasty, x, y);
            g.drawRect(x-2, y-2, 4, 4);
            g.fillRect(x-2, y-2, 4, 4);
            lastx=x; lasty=y;
        }  //end of last for
       return;
   }  //end of paint method
}

public class PlotEachIteration_1 extends Frame{
  ProbingAgent pa;
  PlotIterationPanel pip;

  public PlotEachIteration_1(ProbingAgent p) {
     super("Round="+p.net.probingRound+",Iteration="+p.iteration+"");
     pa = p;
     enableEvents(AWTEvent.WINDOW_EVENT_MASK);
     setBackground(Color.lightGray);
     setLocation( (pa.net.probingRound*pa.maxIteration+pa.iteration-1)*20, (pa.net.probingRound*pa.maxIteration+pa.iteration-1)*20 );
  //   setSize(680, 480);
     Point location;
     location = getLocation();
     pip = new PlotIterationPanel_1(p, location);
     add(pip);
     pack();
     setVisible(true);

     while (!isShowing()) {
     }
  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }
}