
/**
 * Title:        NetLayout0.3<p>
 * Description:  NetLayout0.3 with bottleneck detection<p>
 * Copyright:    Copyright (c) 1999<p>
 * Company:      UCCS<p>
 * @author Jihui Yang
 * @version
 */
package NetLayout;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.text.*;

class ProbingIterationCanvas extends Canvas  {
   int firstx;
   int firsty;
   boolean flag;
   double startTime;
   double endTime;
   ProbingAgent pa;

  public ProbingIterationCanvas(ProbingAgent p, Point location)  {
     double firstx = location.getX();
     double firsty = location.getY();
     flag = true;
     pa = p;
     startTime =  p.sendingTime[1]*1000-1;
     endTime = p.receivingTime[p.noOfMsgs]*1000+1;
  }



  public void enablePaint() {
      flag = true;
  }

  public int getX(int msgNo)  {
     return (firstx+15+58*msgNo);
  }

  public int getY(double time)  {
     double msPerPixel = (endTime - startTime)/400;
     return firsty+300 - (int) ((time - startTime)/msPerPixel);
  }
  public void paint(Graphics g){

 //Color.lightGray    Graphics g = this.getGraphics();

     if (flag) {
         setBackground(Color.lightGray);
         System.out.println("Has been here 2_1");
         Font fn = new Font("Helvetica", Font.PLAIN, 12);    // defina a font
         g.setFont(fn);
         g.drawRect(firstx, firsty, 580, 400);

         double timeRange = endTime - startTime;
         double msPerTick = timeRange/10;
         String timeUnit = "ms";

         for (int i=0; i<=10; i++)  {
            double timeLabel = startTime+msPerTick;
            DecimalFormat doubleDF = new DecimalFormat("####0.###0");
            String label = doubleDF.format(timeLabel)+timeUnit;
            g.drawString(label, 5, firsty+300-i*40);
         }


         for (int i=1; i<10; i++)  {
            DecimalFormat intDF = new DecimalFormat("##0");
            int msgNo= i;
            String label = intDF.format(msgNo);
            g.drawString(label, firstx+15+(i-1)*58, firsty+400+10);
         }
         int lastx = firstx+15;
         int lasty = firsty+300;
         for (int i=1; i<10; i++)  {
            int x = getX(i);
            int y = getY(pa.sendingTime[i]);
            g.setColor(Color.red);
            g.drawLine(lastx, lasty, x, y);
            g.drawRect(x-2, y-2, 4, 4);
            g.fillRect(x-2, y-2, 4, 4);
            lastx=x; lasty=y;
         }

         lastx = firstx+15;
         lasty = firsty+300;
         for (int i=1; i<10; i++)  {
            int x = getX(i);
            int y = getY(pa.sendingTime[i]);
            g.setColor(Color.red);
            g.drawLine(lastx, lasty, x, y);
            g.drawRect(x-2, y-2, 4, 4);
            g.fillRect(x-2, y-2, 4, 4);
            lastx=x; lasty=y;
         }
     }
  }
}



public class Pre_PlotEachIteration extends Frame  {
  ProbingIterationCanvas cl;

  public Pre_PlotEachIteration(ProbingAgent p, Point location) {

      super("Time Divergence of sending and receiving packets");

      cl = new ProbingIterationCanvas(p, location);
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      pack();
      setVisible(true);
      while (!isShowing())  {
      }
      cl.repaint();
  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }
}