//File:         ProbingAgentProperty.java
//Project:      ProbeSim
//Version:      0.2
//Designer:     C. Edward Chow
//Revision:
//              3/9/2000  C. Edward Chow
//Bug Report:   send to chow@cs.uccs.edu
//Description:  Simulator for Internet Network Probing Research
//              Dialog Window for specify property of Probing Agents
//

package NetLayout;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ProbingAgentProperty extends Dialog implements ActionListener {
  final static int size = 30;
  Node n;
  ProbingAgent pa;
  NetLayoutFrame f;
  JPanel panel1 = new JPanel();
  //JPanel panel2 = new JPanel();
  JPanel panel3 = new JPanel();
  JPanel insetsPanel1 = new JPanel();
  //JPanel insetsPanel2 = new JPanel();
  JPanel insetsPanel3 = new JPanel();
  JSeparator sep1 = new JSeparator();
  JSeparator sep2 = new JSeparator();
  JSeparator sep3 = new JSeparator();
  Label statusBar = new Label();

  JButton button1 = new JButton();
  JButton button2 = new JButton();
  JLabel label1 = new JLabel();
  JLabel label2 = new JLabel();
  Label nameLabel = new Label("Name:", Label.RIGHT);
  TextField nameField;
  Label idLabel = new Label("ID:", Label.RIGHT);
  Label idField; // change not allowed
  Label xLabel = new Label("X:", Label.RIGHT);
  TextField xField;
  Label yLabel = new Label("Y:", Label.RIGHT);
  TextField yField;

  Label probingResponderLabel = new Label("Probing Responder Name:", Label.RIGHT);
  TextField probingResponderField;

  Label lonLabel = new Label("Longitude:", Label.RIGHT);
  TextField lonField;
  Label latLabel = new Label("Latitude:", Label.RIGHT);
  TextField latField;
  Label powerLabel = new Label("Power:", Label.RIGHT);
  TextField powerField;
  Label msgSizeLabel = new Label("Probing Message Size:", Label.RIGHT);
  TextField msgSizeField;
  Label noOfMsgsLabel = new Label("No. of Probing Msgs:", Label.RIGHT);
  TextField noOfMsgsField;
  Label bwLowLabel = new Label("Bandwidth Low End:", Label.RIGHT);
  TextField bwLowField;
  Label bwHighLabel = new Label("Bandwidth High End:", Label.RIGHT);
  TextField bwHighField;
  Label bwPreviousLabel = new Label("Bandwidth Previous Estimate:", Label.RIGHT);
  TextField bwPreviousField;
  Label startingTimeLabel = new Label("Starting Time of Probing:", Label.RIGHT);
  TextField startingTimeField;
  Label errorMarginLabel = new Label("Error Margin:", Label.RIGHT);
  TextField errorMarginField;

  Label linkListLabel = new Label("Connected to:", Label.RIGHT);
  Label linkListField;

  BorderLayout borderLayout1 = new BorderLayout();
  //BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  //FlowLayout flowLayout2 = new FlowLayout();
  //GridLayout gridLayout1 = new GridLayout();
  String product = "ProbSim: Probing Simulator Tool Copyright (c) 2000";
  String dialogName = "ProbingAgent Property";

  public ProbingAgentProperty(Frame parent, ProbingAgent c) {
    super(parent);
    f = (NetLayoutFrame) parent;

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit(c);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    pack();
  }

  private void jbInit(ProbingAgent c) throws Exception  {
    this.setTitle("ProbingAgent Property");
    pa = c;
    setResizable(false);
    panel1.setLayout(borderLayout1);
    //panel2.setLayout(borderLayout2);
    panel3.setLayout(borderLayout3);
    insetsPanel1.setLayout(flowLayout1);
    //insetsPanel1.setBevelInner(JPanel.RAISED);
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();
    insetsPanel3.setLayout(gbl);
    //insetsPanel3.setBevelInner(JPanel.RAISED);
    //gridLayout1.setRows(4);
    //gridLayout1.setColumns(1);
    label1.setText(product);
    label2.setText(dialogName);
    //insetsPanel2.setLayout(gridLayout1);
    //insetsPanel2.setLayout(borderLayout1);
    //insetsPanel2.setMargins(new Insets(10, 60, 10, 10));
    //insetsPanel2.setBevelInner(JPanel.FLAT);
    //insetsPanel2.add(label1, null);
    //insetsPanel2.add(label2, null);
    //panel2.add(insetsPanel2, BorderLayout.CENTER);
    //panel1.add(panel2, BorderLayout.NORTH);
    button1.setText("UPDATE");
    button1.addActionListener(this);
    button2.setText("CANCEL");
    button2.addActionListener(this);
    insetsPanel1.add(button1, null);
    insetsPanel1.add(button2, null);
    panel1.add(insetsPanel1, BorderLayout.SOUTH);


    gbc.anchor = GridBagConstraints.CENTER;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(label1, gbc);
    insetsPanel3.add(label1);
    
    gbc.anchor = GridBagConstraints.CENTER;
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(label2, gbc);
    insetsPanel3.add(label2);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep1, gbc);
    insetsPanel3.add(sep1);
    gbc.fill = 0;

    // add code to create name value pair for each property item
    nameField = new TextField(c.name, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(nameLabel, gbc);
    insetsPanel3.add(nameLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(nameField, gbc);
    insetsPanel3.add(nameField);
    
    idField = new Label(Integer.toString(c.ID),Label.LEFT);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(idLabel, gbc);
    insetsPanel3.add(idLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(idField, gbc);
    insetsPanel3.add(idField);

    xField = new TextField(Integer.toString(c.x), size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(xLabel, gbc);
    insetsPanel3.add(xLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(xField, gbc);
    insetsPanel3.add(xField);

    yField = new TextField(Integer.toString(c.y), size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(yLabel, gbc);
    insetsPanel3.add(yLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(yField, gbc);
    insetsPanel3.add(yField);


    Node n = c.net.searchNode(c.probingResponderID);
    if (n == null) probingResponderField = new TextField("", size);
    else  probingResponderField = new TextField(n.name, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(probingResponderLabel, gbc);
    insetsPanel3.add(probingResponderLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(probingResponderField, gbc);
    insetsPanel3.add(probingResponderField);



    lonField = new TextField(""+c.lon, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(lonLabel, gbc);
    insetsPanel3.add(lonLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(lonField, gbc);
    insetsPanel3.add(lonField);

    latField = new TextField(""+c.lat, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(latLabel, gbc);
    insetsPanel3.add(latLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(latField, gbc);
    insetsPanel3.add(latField);

    powerField = new TextField(""+c.power, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(powerLabel, gbc);
    insetsPanel3.add(powerLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(powerField, gbc);
    insetsPanel3.add(powerField);

    msgSizeField = new TextField(""+c.msgSize/8, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(msgSizeLabel, gbc);
    insetsPanel3.add(msgSizeLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(msgSizeField, gbc);
    insetsPanel3.add(msgSizeField);

    noOfMsgsField = new TextField(""+c.noOfMsgs, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(noOfMsgsLabel, gbc);
    insetsPanel3.add(noOfMsgsLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(noOfMsgsField, gbc);
    insetsPanel3.add(noOfMsgsField);

    bwLowField = new TextField(""+c.bwLow, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(bwLowLabel, gbc);
    insetsPanel3.add(bwLowLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(bwLowField, gbc);
    insetsPanel3.add(bwLowField);

    bwHighField = new TextField(""+c.bwHigh, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(bwHighLabel, gbc);
    insetsPanel3.add(bwHighLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(bwHighField, gbc);
    insetsPanel3.add(bwHighField);

    bwPreviousField = new TextField(""+c.bwPrevious, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(bwPreviousLabel, gbc);
    insetsPanel3.add(bwPreviousLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(bwPreviousField, gbc);
    insetsPanel3.add(bwPreviousField);

    startingTimeField = new TextField(""+c.startingTime, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(startingTimeLabel, gbc);
    insetsPanel3.add(startingTimeLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(startingTimeField, gbc);
    insetsPanel3.add(startingTimeField);

    errorMarginField = new TextField(""+c.errorMargin, size);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(errorMarginLabel, gbc);
    insetsPanel3.add(errorMarginLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(errorMarginField, gbc);
    insetsPanel3.add(errorMarginField);


    linkListField = new Label(c.linkListNameToString(), Label.LEFT);
    gbc.anchor = GridBagConstraints.WEST;
    gbc.gridwidth = 1;
    gbc.insets = new Insets(0,0,0,0);
    gbl.setConstraints(linkListLabel, gbc);
    insetsPanel3.add(linkListLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(linkListField, gbc);
    insetsPanel3.add(linkListField);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep2, gbc);
    insetsPanel3.add(sep2);

    gbc.anchor = GridBagConstraints.SOUTH;
    Label statusBarLabel = new Label("status:");
    gbc.gridwidth = 1;
    gbl.setConstraints(statusBarLabel, gbc);
    insetsPanel3.add(statusBarLabel);
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbl.setConstraints(statusBar, gbc);
    insetsPanel3.add(statusBar);

    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.insets = new Insets(0,0,10,0);
    gbl.setConstraints(sep3, gbc);
    insetsPanel3.add(sep3);
    
    panel3.add(insetsPanel3,BorderLayout.CENTER);
    panel1.add(panel3, BorderLayout.CENTER);
    this.add(panel1, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }
  boolean update() {
    String ns = nameField.getText();
    pa.name = ns;
    ns = xField.getText();
    pa.x = Integer.parseInt(ns);
    ns = yField.getText();
    pa.y = Integer.parseInt(ns);

    ns = probingResponderField.getText();
    int id = pa.net.getID(ns);
    if (id == Net.NOTFOUND) {
      statusBar.setText("The probing responder="+ns+" does not exist. Check again.");
      return false;
    }
    pa.probingResponderID = id;
    

    try {
      ns = lonField.getText();
      Double r = Double.valueOf(ns);
      pa.lon = r.doubleValue();
      ns = latField.getText();
      r = Double.valueOf(ns);
      pa.lat = r.doubleValue();
      ns = powerField.getText();
      r = Double.valueOf(ns);
      pa.power = r.doubleValue();
      ns = msgSizeField.getText();
      pa.msgSize = Integer.parseInt(ns)*8;
      ns = noOfMsgsField.getText();
      pa.noOfMsgs = Integer.parseInt(ns);
      ns = bwLowField.getText();
      r = Double.valueOf(ns);
      pa.bwLow = r.doubleValue();
      ns = bwHighField.getText();
      r = Double.valueOf(ns);
      pa.bwHigh = r.doubleValue();
      ns = bwPreviousField.getText();
      r = Double.valueOf(ns);
      pa.bwPrevious = r.doubleValue();
      ns = startingTimeField.getText();
      r = Double.valueOf(ns);
      pa.startingTime = r.doubleValue();
      ns = errorMarginField.getText();
      r = Double.valueOf(ns);
      pa.errorMargin = r.doubleValue();
      pa.interval = pa.msgSize/pa.bwLow;
      pa.intervalStep = pa.msgSize*(pa.bwHigh-pa.bwLow)/(pa.bwHigh*pa.bwLow*(pa.noOfMsgs-2));

    } catch (NumberFormatException e) {
      statusBar.setText("Could not convert string to double/int. ");
      return false;
    }
    f.mapArea.redo();
    return true;
    //System.out.println("update ProbingAgent property, get new name="+newName);
  }
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == button1) {
      if (update()) cancel();
    }
    if (e.getSource() == button2) {
      cancel();
    }
  }
}

