//File:         PlotEachIteration.java
//Project:      ProbeSim
//Version:      0.2
//Designer:     Jihui Yang
//Revision:
//              6/25/2000  Jihui Yang
//Bug Report:   send to yangjihui@yahoo.com
//Description:  Simulator for Internet Network Probing Research
//              Plot(and can print) the msgNo-sendingTime/receivingTime curve of
//              each iteration

package NetLayout;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
import java.text.*;
import java.awt.print.PrinterJob;
import java.awt.print.*;


class PlotIterationPanel extends JPanel implements Printable, ActionListener {

   ProbingAgent pa;
   Net net;
   int startTime;
   int endTime;
   double[] sendingTime;
   double[] receivingTime;
   PrinterJob printJob;


   JButton button = new JButton("Print");

   int panelBeginX = 72;            //The page Imageable X begin from pixel 72
   int panelBeginY = 72;            //The page Imageable Y begin from pixel 72
   int recBeginX = panelBeginX+65;  //65 is the length of time remark such as 3014758ms
 //  int beginY = stringAreaLastY+10;
   int recWidth = 468-65;    //468 is the page Imageable width, 65+recWidth=page Imageable width
   int recHeight = 320;

   int probingRound;
   int iteration;



  //public Post_PlotIterationPanel(ProbingAgent p, Point location)  {
   public PlotIterationPanel(ProbingAgent p)  {
      pa = p;
      net = pa.net;
      iteration = pa.iteration;
      probingRound = net.probingRound;


 //     firstX = (int) location.getX();
 //     firstY = (int) location.getY();
    //  System.out.println("Sending Time is"+pa.sendingTime[1]);
    //  System.out.println("Ending Time is"+pa.receivingTime[pa.noOfMsgs]);
      startTime =  (int) (pa.sendingTime[1]*1000000);
 //     endTime =  (int) ( max( 1000000*( pa.receivingTime[pa.noOfMsgs]-(pa.receivingTime[1]-pa.sendingTime[1]) ), pa.sendingTime[10]*1000000 ) );
      endTime = (int) (pa.receivingTime[pa.noOfMsgs]*1000000 + 1 );
  //    System.out.println("startTime="+startTime);
  //    System.out.println("endTime"+endTime);
      sendingTime = new double[pa.noOfMsgs+1];
      receivingTime = new double[pa.noOfMsgs+1];

      int i;
      for(i=1; i<=pa.noOfMsgs; i++) {
         sendingTime[i] = pa.sendingTime[i];
         receivingTime[i] = pa.receivingTime[i];
      }

      button.addActionListener(this);

   }

   public void actionPerformed(ActionEvent e)  {
      if (e.getSource() instanceof JButton) {
         printJob = PrinterJob.getPrinterJob();
     //    PageFormat pf = printJob.pageDialog(printJob.defaultPage());
     /*    PageFormat pf = new PageFormat();
         System.out.println("Page height is"+pf.getHeight());
         System.out.println("Page width is"+pf.getWidth());
         System.out.println("Page Imagable height is"+pf.getImageableHeight());
         System.out.println("Page imagable width is"+pf.getImageableWidth());
         System.out.println("Page Image X is"+pf.getImageableX());
         System.out.println("Page Image Y is"+pf.getImageableY());  */
    //     System.out.println("The orientation is"+pf.getOrientation());
    //    pf.setOrientation(PageFormat.LANDSCAPE);
    //     System.out.println("The orientation is"+pf.getOrientation());
    //     PageFormat landscape = printJob.defaultPage();
    //     landscape.setOrientation(PageFormat.LANDSCAPE);

         printJob.setPrintable(this);

         if (printJob.printDialog()) {
            try {
                printJob.print();
            } catch (Exception ex)  {
                 ex.printStackTrace();
              }
         }
      }
   }

   public int print(Graphics g, PageFormat pf, int pi) throws PrinterException  {

      if (pi>=1) {
         return Printable.NO_SUCH_PAGE;
      }
      int stringAreaLastY = drawStrings(g);
      drawLines(g, stringAreaLastY);
      return Printable.PAGE_EXISTS;
   }

  public int getX(int msgNo)  {

      int pixcelPerMsg = recWidth/pa.noOfMsgs;
      int x = recBeginX + pixcelPerMsg*(msgNo-1);
  //    System.out.println("X="+x);
      return x;
  }

  public int getY(double time, int recEndY)  {
  //   System.out.println("endTime is"+endTime);
  //   System.out.println("startTime is"+startTime);
  //   System.out.println("height is"+height);
     double timePerPixel = (double) ((endTime - startTime)/ (recHeight+0.0));
  //   System.out.println("TimeperPixel= "+timePerPixel);


 //    System.out.println("Time="+time);
     int y =  recEndY - (int) ((time*1000000 - startTime)/timePerPixel);
 //    System.out.println("Y="+y);
     return y;
  }


  public void paintComponent (Graphics g) {
     int stringAreaLastY;
     super.paintComponent (g);
     stringAreaLastY=drawStrings(g);
     drawLines(g, stringAreaLastY);
  }

  public void drawLines(Graphics g, int stringAreaLastY)  {

 //    System.out.println("StringAreaLastY="+stringAreaLastY);

     int recBeginY = stringAreaLastY+10;

     int recEndY=recBeginY+recHeight;

     g.drawRect(recBeginX, recBeginY, recWidth, recHeight);

     int timeRange = endTime - startTime;
     double msPerTick = timeRange/pa.noOfMsgs;
     int pixcelPerTick = recHeight/pa.noOfMsgs;
     String timeUnit = "ms";


     for (int i=0; i<=pa.noOfMsgs; i++)  {
        double timeLabel = startTime+msPerTick*i;
        DecimalFormat doubleDF = new DecimalFormat("#######.#");
        String label = doubleDF.format(timeLabel)+timeUnit;
        g.drawString( label, panelBeginX, recEndY-i*pixcelPerTick );  //It's (35, 400+beginY-40*i) here
     }

     int pixcelPerMsg = recWidth/pa.noOfMsgs;
     for (int i=1; i<=pa.noOfMsgs; i++)  {
        DecimalFormat intDF = new DecimalFormat("##");
        int msgNo= i;
        String label = intDF.format(msgNo);
        g.drawString(label, recBeginX+(i-1)*pixcelPerMsg, recEndY+20);
     }

     int lastx=recBeginX;
     int lasty=recEndY;
     for (int i=1; i<=10; i++)  {
        int x = getX(i);
        int y = getY(sendingTime[i], recEndY);
   //     System.out.println("This dot should be put to pixel"+y);
        g.setColor(Color.black);
        g.drawLine(lastx, lasty, x, y);
        g.drawRect(x-2, y-2, 4, 4);
        g.fillRect(x-2, y-2, 4, 4);
        lastx=x; lasty=y;
     }

     lastx = recBeginX;
     lasty = recEndY;
     for (int i=1; i<=10; i++)  {
        int x = getX(i);
        int y = getY(receivingTime[i]-(receivingTime[1]-sendingTime[1]), recEndY);

    //    System.out.println("This dot should be put to pixel"+y);
        g.setColor(Color.magenta);
        g.drawLine(lastx, lasty, x, y);
        g.drawRect(x-2, y-2, 4, 4);
        g.fillRect(x-2, y-2, 4, 4);
        lastx=x; lasty=y;
     }  //end of last for

  }  //end of paint method

  public  int drawStrings(Graphics g)  {

     int clientNo=0;       //To record the location of the traffic desc. of clients


     Font fb = new Font("Helvetica", Font.PLAIN, 12);
     g.setColor(Color.black);

     Net net = pa.net;

     String fileNameStr = "Network="+net.fileName;
     g.drawString(fileNameStr, panelBeginX, panelBeginY+15);

  //   stringAreaX += fileNameStr.length()*12+10;

     String trafficTypeStr;
     if(net.trafficType == net.ConstantClientPacket)
        trafficTypeStr = "ConstantClientPacket";
     else if(net.trafficType == net.RandomWebTraffic)
        trafficTypeStr = "RandomWebTraffic";
     else if(net.trafficType == net.SelfSimilarTraffic)
        trafficTypeStr = "SelfSimilarTraffic";
     else trafficTypeStr = "ConstantBitRate";
     g.drawString(trafficTypeStr, panelBeginX+100, panelBeginY+15);
     g.drawString("R"+probingRound+"I"+iteration, panelBeginX+230, panelBeginY+15);

     g.drawString("Pkt Size", panelBeginX+100, panelBeginY+15*2);
     g.drawString("InterArrival Time", panelBeginX+280, panelBeginY+15*2);
     g.drawString("min", panelBeginX+55, panelBeginY+15*3);
     g.drawString("max", panelBeginX+115, panelBeginY+15*3);
     g.drawString("avg", panelBeginX+175, panelBeginY+15*3);
     g.drawString("min", panelBeginX+255, panelBeginY+15*3);
     g.drawString("max", panelBeginX+315, panelBeginY+15*3);
     g.drawString("avg", panelBeginX+365, panelBeginY+15*3);





     for(int i=0; i<net.nodes.size(); i++)  {
        Node n = (Node) net.nodes.elementAt(i);

        if ( n.type == net.PROBE)  {
           Node nextNode = (Node) n;
           double bottleneckBW=1.0E9; //Give a very large initial value
           while (nextNode.type != net.PROBERCV)  {
              Link l = net.getNextLink(nextNode.ID, pa.probingResponderID);

             /* if(nextNode.ID == n.ID)  //The beginning of the search for bottleneckBW
                 bottleneckBW = l.bandwidth; */
             /* else */  //other links along the path from probingAgent to probingResponder
              bottleneckBW = java.lang.Math.min(l.bandwidth, bottleneckBW);

              nextNode = (l.n1 == nextNode) ? l.n2 : l.n1;
           }

           g.drawString("BottleneckBW="+bottleneckBW, panelBeginX+270, panelBeginY+15);
        }

        if (n.type == net.CLIENT)  {
           Client c = (Client) n;

           if( ( net.trafficType == net.ConstantClientPacket &&
                 c.reqIDTSt.distType == net.ConstantClientPacket ) ||
               ( net.trafficType == net.RandomWebTraffic &&
                 c.reqIDTSt.distType == net.RandomWebTraffic ) ||
               ( net.trafficType == net.SelfSimilarTraffic &&
                 c.reqIDTSt.distType == net.SelfSimilarTraffic ) )   {

                 g.drawString("Client"+c.ID, panelBeginX, panelBeginY+15*4+15*clientNo); //client0 will be in 4th row

                 DecimalFormat doubleDF = new DecimalFormat("#.######");

                 String label = doubleDF.format(c.reqDocSt.min);
                 g.drawString(label, panelBeginX+55, panelBeginY+15*4+15*clientNo);
                 label = doubleDF.format(c.reqDocSt.max);
                 g.drawString(label, panelBeginX+115, panelBeginY+15*4+15*clientNo);
                 label = doubleDF.format(c.reqDocSt.avg);
                 g.drawString(label, panelBeginX+175, panelBeginY+15*4+15*clientNo);
                 label = doubleDF.format(c.reqIDTSt.min);
                 g.drawString(label, panelBeginX+255, panelBeginY+15*4+15*clientNo);
                 label = doubleDF.format(c.reqIDTSt.max);
                 g.drawString(label, panelBeginX+315, panelBeginY+15*4+15*clientNo);
                 label = doubleDF.format(c.reqIDTSt.avg);
                 g.drawString(label, panelBeginX+365, panelBeginY+15*4+15*clientNo);

                 clientNo++;   //Only need to print or paint "effctive" client
           }  //end of if ( (net....
        }  //end of if (n.type...
        if (n.type == net.SERVER)  {
           Server cs = (Server) n;
           g.drawString("Server"+cs.ID, panelBeginX, panelBeginY+15*4+15*clientNo);
           DecimalFormat doubleDF = new DecimalFormat("#.######");
           String label = doubleDF.format(cs.reqDocSt.min);
           g.drawString(label, panelBeginX+55, panelBeginY+15*4+15*clientNo);
           label = doubleDF.format(cs.reqDocSt.max);
           g.drawString(label, panelBeginX+115, panelBeginY+15*4+15*clientNo);
           label = doubleDF.format(cs.reqDocSt.avg);
           g.drawString(label, panelBeginX+175, panelBeginY+15*4+15*clientNo);

           clientNo++;
        }
     } //end of for



  int stringAreaLastY = panelBeginY+15*4+15*clientNo;
  return stringAreaLastY;

  }
}

public class PlotEachIteration extends JFrame {
  ProbingAgent pa;
  public PlotEachIteration(ProbingAgent p) {
     pa = p;
     setTitle ("Round="+p.net.probingRound+",Iteration="+p.iteration+"");
     setSize (612, 640);
     setLocation( (pa.net.probingRound*pa.maxIteration+pa.iteration-1)*20, (pa.net.probingRound*pa.maxIteration+pa.iteration-1)*20 );
     enableEvents(AWTEvent.WINDOW_EVENT_MASK);

 //    Point location;
 //    location = getLocation();
     Container contentPane = getContentPane();
 //    Post_PlotIterationPanel post_PlotIterationPanel = new Post_PlotIterationPanel(pa, location);
     PlotIterationPanel PlotIterationPanel = new PlotIterationPanel(pa);
     PlotIterationPanel.add (PlotIterationPanel.button);
     contentPane.add (PlotIterationPanel);
     show();

  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }
}
